---------------------------------------------------
--                                               --
--   POINT_BLANK-style script by Cliffe_Snake    --
--                   June 2010                   --
--                  version 0.38                 --
---------------------------------------------------           
ver=0.38 
lang="ru" -- change it to "en" to enable English version


-- Game-configuration
parse("mp_wpndmg_z1 awp 66")
parse("mp_wpndmg ak-47 23")
parse("mp_infammo 0")
parse ("mp_killinfo 0")

color = {'255176000','000255000','255255000','255000000','160170255','250120000','255255255','100255100'}
str={
		["ru"] = {t_id={
							[1]=": +",
							[2]=": ",
							[3]=": ",
							[4]="!",
							[5]="  !",
							[6]=" !",
							[7]=" !",
							[8]=" ",
							[9]=". ",
							[10]=" !!!",
							[11]="M!!!",
							[12]=" !",
							[13]=" !",
							[14]="  !",
							[15]="   ."
						}},
		["en"] = {t_id={
							[1]="Purchased: Vest+Helmet",
							[2]="Purchased: Vest",
							[3]="Purchased: Helmet",
							[4]="Cutthroat!",
							[5]="Headshot!",
							[6]="Helmet protection!",
							[7]="Knife master!",
							[8]="Knife dmg",
							[9]="Maximum dmg",
							[10]="You kill master!!!",
							[11]="Master!!!",
							[12]="Triple kill!",
							[13]="Double kill!",
							[14]=" became master!",
							[15]=" still have level of master."
						}}
	}
help=true

addhook("join","pb_join")
function pb_join(id)
	if lang=="en" then msg2(id,color[2].."Welcome on my PB-Server, "..player(id,"name").."!") end
	if lang=="ru" then msg2(id,color[2]..", "..player(id,"name")..",   PB-! =)") end	
	lng[id]=lang
--------------------------------------------------------------------------------------------------------
--    if load[id] == 0 then
--        if (player(id,"usgn") > 0) then
--            local usgn = player(id, "usgn")
--            RPG_data = io.open(load_data..'RPG_data/'..player(id,"usgn")..'.txt','r')
--            if (RPG_data ~= nil) then
--                for line in io.lines(load_data..'RPG_data/'..player(id,"usgn")..'.txt','r') do
--                    local parses = totable(line)
--                   if (tonumber(parses[1]) > 0) then
--                        experience[id] = tonumber(parses[1])
--                        RPG_data:close()
--                    end
--                end
--			end
--        end
--        load[id] = 1
--   end
-------------------------------------------------------------------------------------
end

addhook("minute","pb_minute")
function pb_minute()
	if not help then
		if lang=="en" then msg(color[5].."This PB-server v"..ver.." powered by Cliffe_Snake") end
		if lang=="ru" then msg(color[5].."- : "..ver.."  Cliffe_Snake") end
		help=true
	else
		if lang=="ru" then msg(color[5]..'Type "!en" to enable English language') end
		if lang=="en" then msg(color[5]..'Type "!ru" to enable Russian language') end
		help=false
	end
end

addhook("say","pb_say")
addhook("sayteam","pb_say")
function pb_say(id,txt)
	if txt=="!ru" then lng[id]="ru"; msg2(id,color[2].." ."); return 1; end
	if txt=="!en" then lng[id]="en"; msg2(id,color[2].."Language changed."); return 1; end
	return 0
end

function array(m)
    local array = {}
    for i = 1, m do
        array[i] = 0
    end
    return array
end

function set(m,value)
    local array = {}
    for i = 1, m do
        array[i] = value
    end
    return array
end


function pb_msg(p,c,t)
	msg2(p,color[c]..''..t..'@C')
end

function  conv(id,txt)
	--if (player(id,"name")==game("name")) then
		if hudhelm[id]~=0 then freeimage(hudhelm[id]) end
			hudhelm[id]=image("gfx/pb/helm.bmp",122,432,2)
			imageblend(hudhelm[id],1)
			imagecolor(hudhelm[id],255,255,0)
			imagealpha(hudhelm[id],0.75)
		local k
		for i=1,3 do
			if nimg[i]~=0 then freeimage(nimg[i]) end
		end	
		if helm[id]<=0 then txt="  0" end
		k=string.len(txt)
		if k==2 then txt=" "..txt end
		if k==1 then txt="  "..txt end
		for i = 1 , 3 do
			num[i]=string.sub(txt,i,i)
		end
		for i=1,3 do
			nimg[i]=image("gfx/pb/nums/"..num[i]..".bmp",147+(i-1)*22,432,2)
			imageblend(nimg[i],1)
			imagescale(nimg[i],0.82,0.82)
			imagecolor(nimg[i],255,255,0)
			imagealpha(nimg[i],0.5)
		end	
		phelm[id]=helm[id]
	--end	
end

function sdvig(id,txt)
	if (player(id,"name")==game("name")) then
		if txt~="_" then
			for i = 10,2,-1 do
				players[id].istar[i]=players[id].istar[i-1]
			end
			players[id].istar[1]=txt
		end	
		for j = 1 , 10 do
			if slot[j]~=0 then freeimage(slot[j]) end
			if players[id].istar[j]~="" then
				slot[j]=image("gfx/pb/"..players[id].istar[j]..".png",640-j*50,24,2)
			end	
		end 
	end
end

  p_cnt = game('sv_maxplayers')
  kk = array(p_cnt)			-- knive kills
  hed = array(p_cnt)		-- headshot kills
  star = array(p_cnt)		-- star count
  helm = array(p_cnt)		-- HelmetPoints
  phelm  = array(p_cnt)		-- helmet state
  hudhelm = array(p_cnt)	-- hud helmet image
  admg = array(p_cnt)		-- additional damage by knive
  pl = array(p_cnt)			-- dontplay master sound
  sarge = array(p_cnt)		-- is a master
  players = set(p_cnt,{istar={[1]="",[2]="",[3]="",[4]="",[5]="",[6]="",[7]="",[8]="",[9]="",[10]=""}})
  slot = array(10)  -- images to draw kill-stars
  num = array(3)    -- text_id to draw HelmPoints
  nimg = array(3)	-- images to draw HelmPoints
  lng = set(p_cnt,lang)  -- to change language
  

addhook("always","pb_stars")
function pb_stars()
	for i = 1 , p_cnt do
		if (player(i,"name")==game("name")) then
			if phelm[i]~=helm[i] then conv(i,helm[i]) end
		end
	end
end  

--addhook("spawn","pb_spawn")
--function pb_spawn(id)

--end

addhook("startround","pb_restart")
function pb_restart(mode)
	for i = 1 , p_cnt do
		if (player(i,"name")==game("name")) then
			conv(i,helm[i])
			sdvig(i,"_")
		end
		if (star[i]>3) then sarge[i]=image("gfx/pb/sarge.png",1,0,200+i); msg(player(i,"name")..str[lng[i]].t_id[15]) end
		if (star[i]==0) then pl[i]=false end
	end

end

addhook("die","pb_die")
function pb_die(victim,killer,weapon,x,y)
	kk[victim]=0
	star[victim]=0
	hed[victim]=0
	helm[victim]=0
	phelm[victim]=0
	admg[victim]=0
	pl[victim]=false
	if sarge[victim]~=0 then freeimage(sarge[victim]) end
	sarge[victim]=0

	if (player(victim,"name")==game("name")) then
		for i=1,10 do
			players[victim].istar[i]=""
		end
		for j = 1 , 10 do
			if slot[j]~=0 then freeimage(slot[j]) end
		end 
		--conv(victim,"  0")
		if hudhelm[victim]~=0 then freeimage(hudhelm[victim]) end
		for i=1,3 do
			if nimg[i]~=0 then freeimage(nimg[i]) end
		end	
	end
end

addhook("buy","pb_buy")
function pb_buy(id,wpn)
 local w,h,i,j,x,y
 w=map("xsize")
 h=map("ysize")
 for i = -2 , 2 do
  for j = -2 , 2 do
    x=i+player(id,"tilex")
    y=j+player(id,"tiley")
    if (x>0) and (y>0) and (x<=w) and (y<=h) then
		if ((entity(x,y,"typename")=="Info_T") and (player(id,"team")==1)) or ((entity(x,y,"typename")=="Info_CT") and (player(id,"team")==2)) then
			if (wpn==58) then 
				if (player(id,"armor")<100) then      --      
                    if (helm[id]<100) then      --      +
                        if (player(id,"money")>=1200) then
                            helm[id]=100 
                            parse("setarmor "..id.." "..100); 
                            parse("setmoney "..id.." "..player(id,"money")-1200)
                            msg2(id,color[2]..str[lng[id]].t_id[1])
						    if (player(id,"name")==game("name")) then 
						        parse('sv_sound "pb/armoron_1.wav"')
						    end	 
                        end
                    else                      --      
                        if (player(id,"money")>=650) then 
                            parse("setarmor "..id.." "..100); 
                            parse("setmoney "..id.." "..player(id,"money")-650)
                            msg2(id,color[2]..str[lng[id]].t_id[2])
                        end                         
                    end
				else              --   ,
                    if (helm[id]<100) then      --       
                        if (player(id,"money")>=550) then
                            helm[id]=100
                            parse("setmoney "..id.." "..player(id,"money")-550)
                            msg2(id,color[2]..str[lng[id]].t_id[3])
						    if (player(id,"name")==game("name")) then 
								parse('sv_sound "pb/armoron_1.wav"')
						    end	 
                        end                       
                    end
				end 
			end  
			if (wpn==57 and player(id,"armor")<100 and player(id,"money")>=650) then   --  100%    
				parse("setarmor "..id.." "..100);  
				parse("setmoney "..id.." "..player(id,"money")-650)
				msg2(id,color[2]..str[lng[id]].t_id[2])
			end
		end
    end
  end
 end
end

addhook("hit","pb_hit")
function pb_hit(victim,killer,weapon,hpdmg,apdmg)
    local i,hp,kv,kd 
	if (weapon>=20 and weapon<34) or (weapon>35 and weapon<41) then
		if (star[killer]<15) then 
			i=math.random(1,10+star[killer]) -- 10%..4%    ( )
		else 
			i=math.random(1,25) 			-- 4%    
		end 
	else
		if (star[killer]<13) then 
			i=math.random(1,7+star[killer]) -- 15%..5%    (  )
		else 
			i=math.random(1,20) 			-- 5%    
		end     
    end
	kv=1-game("mp_kevlar")
	if (weapon==50) then kd=admg[killer] else kd=0 end
    if (i==1 and (weapon<41 or weapon==50 or weapon==69 or weapon==74)) then  --    ,   
        i = math.random(1,5+(math.ceil(helm[victim]/10)>0 and math.ceil(helm[victim]/10) or 1))    --     ( i<5   )
        if (helm[victim]<1 or i<6) then    --      
			hp=player(victim,"health");
			if player(victim,"armor")>0 then hp=hp-(hpdmg/kv+kd)*3 else hp=hp-(hpdmg+kd)*3 end            --      
			if (hp<1) then        -- -
				pl[killer]=true
				if (itemtype(weapon,"name")~='Mac 10') then
					parse('customkill '..killer..' =(0_o)=>'..itemtype(weapon,"name")..' '..victim)
				else
					parse('customkill '..killer..' =(0_o)=>Mac-10 '..victim)
				end 
				if (weapon==50) then   --  
					kk[killer]=kk[killer]+1
					parse('setmoney '..killer..' '..player(killer,"money")+120)
				end   
				hed[killer]=hed[killer]+1    
				if (hed[killer]>2) then 
					pb_msg(killer,3,str[lng[killer]].t_id[4].." +120$ Helmet+15%");
					if helm[killer]<86 then helm[killer]=helm[killer]+15 else helm[killer]=100 end
					parse('setmoney '..killer..' '..player(killer,"money")+120)
					sdvig(killer,"golovorez")
					if (player(killer,"name")==game("name")) then 
						parse('sv_sound "pb/pb_cherepovert.wav"')
					end
				else
					if (hed[killer]<3) then
						pb_msg(killer,3,str[lng[killer]].t_id[5].." +60$ Helmet+10%");
						if helm[killer]<91 then helm[killer]=helm[killer]+10 else helm[killer]=100 end
						parse('setmoney '..killer..' '..player(killer,"money")+60)
						sdvig(killer,"headshot")
						if (player(killer,"name")==game("name")) then 
							parse('sv_sound "pb/pb_head.wav"')
						end
					end
				end;
				return 1;
			else        -- -
				parse("sethealth "..victim.." "..hp);
				if (player(victim,"name")==game("name")) then 
					parse('sv_sound "pb/headshot.wav"')
				end
				return 1;
			end
        else
			if (player(victim,"name")==game("name")) then 
				parse('sv_sound "pb/helm'..math.random(1,3)..'.ogg"')
			end
            pb_msg(victim,2,str[lng[victim]].t_id[6]);
			helm[victim]=helm[victim]-apdmg
            return 1
        end
    else
        if (weapon<41 or weapon==50 or weapon==69 or weapon==74 or weapon==78 or weapon==85) then
            hp=player(victim,"health")
		    if player(victim,"armor")>0 then 
				hp=hp-(hpdmg/kv+kd)*(1-(1-kv)*player(victim,"armor")/100)
			else 
				hp=hp-hpdmg-kd
			end
            if (hp<1) then
				if (weapon==50) then   --  
					kk[killer]=kk[killer]+1
					if (kk[killer]>2) then
						pl[killer]=true					
						parse('setmoney '..killer..' '..player(killer,"money")+120)
						if admg[killer]<10 then 
							pb_msg(killer,5,str[lng[killer]].t_id[7].." +120$ "..str[lng[killer]].t_id[8].." +1");
							admg[killer]=admg[killer]+1 
						else
							pb_msg(killer,5,str[lng[killer]].t_id[7].." +120$ "..str[lng[killer]].t_id[9]);
						end
						sdvig(killer,"knive")
						if (player(killer,"name")==game("name")) then
							parse('sv_sound "pb/pb_knive_god.wav"')
						end
					end	
			    end   				
                if (itemtype(weapon,"name")~='Mac 10') then
			        parse('customkill '..killer..' '..itemtype(weapon,"name")..' '..victim)
				else
				    parse('customkill '..killer..' Mac-10 '..victim)
				end 
            else
                parse("sethealth "..victim.." "..hp);
            end
            parse("setarmor "..victim.." "..(player(victim,"armor")-apdmg/3)); 
            return 1
        end
    end
end


addhook("kill","pb_kills")
function pb_kills(killer,victim,weapon,x,y)
    star[killer]=star[killer]+1
	if (star[killer]>3) and (sarge[killer]==0) then sarge[killer]=image("gfx/pb/sarge.png",1,0,200+killer); msg(player(killer,"name")..str[lng[killer]].t_id[14]) end
    if (star[victim]>3) then   
        pb_msg(killer,6,str[lng[killer]].t_id[10].." +180$ 100hp 200ap")
		parse('setmoney '..killer..' '..player(killer,"money")+180)
		parse('sethealth '..killer..' 100')
		parse('setarmor '..killer..' 200')
		sdvig(killer,"killmaster")
        if (player(killer,"name")==game("name")) then 
            parse('sv_sound "pb/pb_master_killer.wav"')
        end
    else
	    if (not pl[killer]) then
            if (star[killer]>3) then 
                pb_msg(killer,1,str[lng[killer]].t_id[11].." +60$ +10hp +5ap");
				parse('setmoney '..killer..' '..player(killer,"money")+60)
				if player(killer,"health")<91 then parse('sethealth '..killer..' '..player(killer,"health")+10) else parse('sethealth '..killer..' 100') end
				if player(killer,"armor")<96 then parse('setarmor '..killer..' '..player(killer,"armor")+5) else if player(killer,"armor")<100 then parse('setarmor '..killer..' 100') end end
				sdvig(killer,"master")
                if (player(killer,"name")==game("name")) then 
                    parse('sv_sound "pb/pb_master.wav"')
                end
            else
                if (star[killer]==3) then
                    pb_msg(killer,1,str[lng[killer]].t_id[12].." +30hp +15ap");
					if player(killer,"health")<71 then parse('sethealth '..killer..' '..player(killer,"health")+30) else parse('sethealth '..killer..' 100') end
					if player(killer,"armor")<86 then parse('setarmor '..killer..' '..player(killer,"armor")+15) else if player(killer,"armor")<100 then parse('setarmor '..killer..' 100') end end
                    if (player(killer,"name")==game("name")) then 
                        parse('sv_sound "pb/pb_triple.wav"')
                    end
                else
                    if (star[killer]==2) then
                        pb_msg(killer,1,str[lng[killer]].t_id[13].." +20hp +10ap");
						if player(killer,"health")<81 then parse('sethealth '..killer..' '..player(killer,"health")+20) else parse('sethealth '..killer..' 100') end
						if player(killer,"armor")<91 then parse('setarmor '..killer..' '..player(killer,"armor")+10) else if player(killer,"armor")<100 then parse('setarmor '..killer..' 100') end end
                        if (player(killer,"name")==game("name")) then 
                             parse('sv_sound "pb/pb_double.wav"')
                        end
                    end
                end
				sdvig(killer,"kill")
            end
		end	
    end
    pl[killer]=false
end


------------------
-- Leave\Save --
------------------
--save_data = 'sys/lua/pb/'
--addhook("leave","pb_save") 
--function pb_save(id) 
--    if (player(id,"usgn") > 0) then -- Saves for U.S.G.N. 
--		file = assert(io.open(save_data.."/"..player(id,"usgn")..".txt",'w'))  -- Makes file with usgn id name. 
--		file:write(experience[id],"\n",level[id],"\n",buildlevel[id],"\n",athleticslevel[id])
--		file:close() 
--	end 
--end
------------------
------------------
