-------------------------------------------------------------------
-- This file is where your Lua server scripts go!                --
--                                                               --
-- There are some sample scripts availabe! Just remove the       --
-- comments ("--") in front of the dofile-lines to activate them!--
--                                                               --
-- All samples are stored in subtables of the Lua table "sample" --
--                                                               --
--                                                               --
-- Enjoy! :D                                                     --
-------------------------------------------------------------------

-------------------------------------------------------------------
-- Mod: sample.ads                                               --
-- Just a welcome message + Advertising every minute             --
-- hooks: join, minute                                           --
-------------------------------------------------------------------
-- dofile("sys/lua/samples/advertise.lua")


-------------------------------------------------------------------
-- Mod: sample.badwords                                          --
-- A very simple badwords filter. Kicks players who use bad words--
-- hooks: say                                                    --
-------------------------------------------------------------------
-- dofile("sys/lua/samples/badwords.lua")


-------------------------------------------------------------------
-- Mod: sample.sayfuncs                                          --
-- Some additional say functions like date, time, idlers etc.    --
-- hooks: say                                                    --
-------------------------------------------------------------------
-- dofile("sys/lua/samples/sayfunctions.lua")


-------------------------------------------------------------------
-- Mod: sample.ut                                                --
-- Adds UT Sounds like Humiliation, Doublekill, Multikill, etc.  --
-- hooks: startround, kill                                       --
-------------------------------------------------------------------
-- dofile("sys/lua/samples/utsfx.lua")


-------------------------------------------------------------------
-- Mod: sample.console                                           --
-- Adds console commands "myserverinfo" and "healthlist"         --
-- hooks: parser                                                 --
-------------------------------------------------------------------
-- dofile("sys/lua/samples/console.lua")


-------------------------------------------------------------------
-- Mod: sample.regonly                                           --
-- Only registered players are allowed to join a team            --
-- hooks: team                                                   --
-------------------------------------------------------------------
-- dofile("sys/lua/samples/regonly.lua")


-------------------------------------------------------------------
-- Mod: sample.classes                                           --
-- Different player classes with different weapons               --
-- hooks: team,menu,spawn,buy,walkover,drop,die,serveraction     --
-------------------------------------------------------------------
-- dofile("sys/lua/samples/classes.lua")


-------------------------------------------------------------------
-- Mod: sample.fast                                              --
-- Make all players faster                                       --
-- hooks: spawn                                                  --
-------------------------------------------------------------------
-- dofile("sys/lua/samples/fastplayers.lua")


-------------------------------------------------------------------
-- Mod: sample.gg                                                --
-- Simple Gun Game Mod                                           --
-- hooks: startround,join,spawn,kill,buy,walkover,drop,die       --
-------------------------------------------------------------------
-- dofile("sys/lua/samples/gungame.lua")
-- dofile("sys/lua/ultimate.lua")
dofile("sys/lua/pb.lua")
dofile("sys/lua/reload.lua")